<template lang="pug">
form(@submit.prevent="onSubmit")
  div.form-group
    input.form-input#input-email(ref="email" type="text" placeholder="Email" v-model="credentials.email" v-validate="'email'" data-vv-as="email" name="email" required autofocus)
  div.form-group
    input.form-input#input-password(type="password" placeholder="Password" v-model="credentials.password" name="password" required)
  div.form-group
    z-button.btn-primary(:disabled="errors.any() || !isComplete") {{ $t('login') }}
  div
    nuxt-link(:to="{ path: localePath('account-reset') }") {{ $t('password forgotten') }}
</template>

<script>
import { mapActions, mapMutations, mapGetters } from 'vuex'

export default {
  data() {
    return {
      submitting: false,
      error: null,
      credentials: {
        email: '',
        password: ''
      },
      rememberMe: false
    }
  },
  computed: {
    isComplete() {
      return this.credentials.email && this.credentials.password
    },
    ...mapGetters('user', ['isSetup'])
  },
  mounted() {
    if (this.$route.query.to === 'login') {
      this.$nextTick(() => this.$refs.email.focus())
    }
  },
  methods: {
    async onSubmit() {
      this.submitting = true
      const res = await this.authentify({
        credentials: this.credentials,
        remember: this.rememberMe
      })
      this.submitting = false

      if (res.success) {
        if (this.isSetup) {
          this.$router.push(this.localePath('home'))
        } else {
          this.$router.push(this.localePath({ name: 'account-setup' }))
        }
      } else {
        this.$toast.error(res.errors[1], { icon: 'warning' })
      }
    },
    async onLogout() {
      await this.$apolloHelpers.onLogout()
      this.logout()
    },
    ...mapMutations('auth', ['logout']),
    ...mapActions('auth', ['authentify'])
  },
  $_veeValidate: {
    validator: 'new'
  }
}
</script>

<style scoped>
form {
  text-align: left;
}

button {
  width: 100%;
}
</style>
